/*-
 * SPDX-License-Identifier: BSD-3-Clause
 *
 * Copyright (c) 2018 Rafal Kozik
 * All rights reserved.
 */

.syntax unified

.section .vector_table,"ax",%progbits
.long _estack
.long start + 1
.rept	33
.long	0
.endr
.long   ui + 1

start:
/* copy .data from Flash do RAM */
LDR r0, =_sidata
LDR r1, =_sdata
LDR r2, =_edata
copy_data:
CMP r1, r2
BEQ end_copy_data
LDR r3, [r0]
STR r3, [r1]
ADDS r0, #4
ADDS r1, #4
B copy_data
end_copy_data:

/* zero .bss section */
LDR r0, =_sbss
LDR r1, =_ebss
MOVS r2, #0
zero_bss:
CMP r0, r1
BEQ end_zero_bss
STR r2, [r0]
ADDS r0, #4
B zero_bss
end_zero_bss: 

/* call main */
BL main

/* main should not return */
end:
B end
